%written by: David Shen & John Bartos
%debugged by: David Shen & John Bartos
%tested by: David Shen & John Bartos


function varargout = sedemo1(varargin)
% SEDEMO1 MATLAB code for sedemo1.fig
%      SEDEMO1, by itself, creates a new SEDEMO1 or raises the existing
%      singleton*.
%
%      H = SEDEMO1 returns the handle to a new SEDEMO1 or the handle to
%      the existing singleton*.
%
%      SEDEMO1('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SEDEMO1.M with the given input arguments.
%
%      SEDEMO1('Property','Value',...) creates a new SEDEMO1 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before sedemo1_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to sedemo1_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help sedemo1

% Last Modified by GUIDE v2.5 17-Apr-2013 19:23:34

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @sedemo1_OpeningFcn, ...
    'gui_OutputFcn',  @sedemo1_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before sedemo1 is made visible.
function sedemo1_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to sedemo1 (see VARARGIN)

% Choose default command line output for sedemo1
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

%initialize simulation
reloadinventory_Callback(hObject, eventdata, handles);


% UIWAIT makes sedemo1 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = sedemo1_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in reloadinventory.
function reloadinventory_Callback(hObject, eventdata, handles)
% hObject    handle to reloadinventory (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%restock inventory
set(handles.uitable1, 'Data', {'a',2500,0;'b',1000,0;'c',2000,0;'d',1500,0});

%reset day/week count
set(handles.daynumber, 'String', '0')
set(handles.weeknumber, 'String', '0')

%reset history
set(handles.dayhistorytable, 'Data', {0;0;0;0;0;0;0})
set(handles.weekhistorytable, 'Data', {0;0;0;0})

%reset other stuff
set(handles.statustext, 'String', '')
set(handles.restockstatus, 'String', '')

%restock thrshold hardcoded at 25%
global thresholds
thresholds = [2500 / 4, 1000 / 4, 2000 / 4, 1500 / 4];

%set all past usage to 0
global previousdays
global previousweeks

previousdays = zeros(4,7);
previousweeks = zeros(4,4);

%for first day, make yesterday's stock equal to initial stock
initdata = get(handles.uitable1, 'Data');

global ay
global by
global cy
global dy

ay = initdata{1,2};
by = initdata{2,2};
cy = initdata{3,2};
dy = initdata{4,2};

%values for last week instead of yesterday
global alw
global blw
global clw
global dlw

alw = initdata{1,2};
blw = initdata{2,2};
clw = initdata{3,2};
dlw = initdata{4,2};


% --- Executes on button press in addrandom.
function addrandom_Callback(hObject, eventdata, handles)
% hObject    handle to addrandom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

data = get(handles.uitable1, 'Data');

%add some stuff
data{1,2} = data{1,2} - round(12 + 4 * rand(1));
data{2,2} = data{2,2} - round(5 + 3 * rand(1));
data{3,2} = data{3,2} - round(8 + 3 * rand(1));
data{4,2} = data{4,2} - round(2 + 2 * rand(1));

set(handles.uitable1, 'Data', data)


% --- Executes on button press in nextday.
function nextday_Callback(hObject, eventdata, handles)
% hObject    handle to nextday (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global ay
global by
global cy
global dy

global alw
global blw
global clw
global dlw

global previousdays
global previousweeks

global thresholds

%get end of day numbers
datatoday = get(handles.uitable1, 'Data');
at = datatoday{1,2};
bt = datatoday{2,2};
ct = datatoday{3,2};
dt = datatoday{4,2};

%calculate amount used today
adiff = at - ay;
bdiff = bt - by;
cdiff = ct - cy;
ddiff = dt - dy;

%put values into arrays
previousdays(:,1) = previousdays(:,2);
previousdays(:,2) = previousdays(:,3);
previousdays(:,3) = previousdays(:,4);
previousdays(:,4) = previousdays(:,5);
previousdays(:,5) = previousdays(:,6);
previousdays(:,6) = previousdays(:,7);
previousdays(:,7) = [adiff;bdiff;cdiff;ddiff];

%display
dayhistory = get(handles.dayhistorytable, 'Data');
dayhistory{7} = dayhistory{6};
dayhistory{6} = dayhistory{5};
dayhistory{5} = dayhistory{4};
dayhistory{4} = dayhistory{3};
dayhistory{3} = dayhistory{2};
dayhistory{2} = dayhistory{1};
dayhistory{1} = adiff + bdiff + cdiff + ddiff;

set(handles.dayhistorytable, 'Data', dayhistory)

%set today's numbers to yesterday; prepare for tomorrow
ay = at;
by = bt;
cy = ct;
dy = dt;

%update day/week counters
dayvariable = get(handles.daynumber, 'String');
weekvariable = get(handles.weeknumber, 'String');

set(handles.daynumber, 'String', str2num(dayvariable) + 1)

%do things each week
if mod(str2num(dayvariable), 7) == 0
    %the following if statement prevents the program from adding to the
    %week counter on day 1
    if str2num(dayvariable) > 5
        %increment week counter
        set(handles.weeknumber, 'String', str2num(weekvariable) + 1);
        
        %get data for this week
        atw = datatoday{1,2};
        btw = datatoday{2,2};
        ctw = datatoday{3,2};
        dtw = datatoday{4,2};
        
        %calculate usage
        awdiff = atw - alw;
        bwdiff = btw - blw;
        cwdiff = ctw - clw;
        dwdiff = dtw - dlw;
        
        %add to history matrix
        previousweeks(:,1) = previousweeks(:,2);
        previousweeks(:,2) = previousweeks(:,3);
        previousweeks(:,3) = previousweeks(:,4);
        previousweeks(:,4) = [awdiff;bwdiff;cwdiff;dwdiff];
        
        %update history display
        weekhistory = get(handles.weekhistorytable, 'Data');
        weekhistory{4} = weekhistory{3};
        weekhistory{3} = weekhistory{2};
        weekhistory{2} = weekhistory{1};
        weekhistory{1} = awdiff + bwdiff + cwdiff + dwdiff;
        
        set(handles.weekhistorytable, 'Data', weekhistory)
        
        %set values for next week        
        alw = atw;
        blw = btw;
        clw = ctw;
        dlw = dtw;
    end
    
    %check for restocks, perform if necessary
    today = get(handles.daynumber, 'String');
    
    if datatoday{1,2} < thresholds(1)
        set(handles.restockstatus, 'String', ['Restocked A on day ', today])
        datatoday{1,2} = 2500;
        ay = datatoday{1,2};
        alw = datatoday{1,2};
    elseif datatoday{2,2} < thresholds(2)
        set(handles.restockstatus, 'String', ['Restocked B on day ', today])
        datatoday{2,2} = 1000;
        by = datatoday{2,2};
        blw = datatoday{2,2};
    elseif datatoday{3,2} < thresholds(3)
        set(handles.restockstatus, 'String', ['Restocked C on day ', today])
        datatoday{3,2} = 2000;
        cy = datatoday{3,2};
        clw = datatoday{3,2};
    elseif datatoday{4,2} < thresholds(4)
        set(handles.restockstatus, 'String', ['Restocked D on day ', today])
        datatoday{4,2} = 1500;
        dy = datatoday{4,2};
        dlw = datatoday{4,2};
    end

    set(handles.uitable1, 'Data', datatoday)
    
    updatepredictions_Callback(hObject, eventdata, handles)
end


% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in updatepredictions.
function updatepredictions_Callback(hObject, eventdata, handles)
% hObject    handle to updatepredictions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global previousdays
global previousweeks

global thresholds

tmpdays = previousdays;

currentweek = get(handles.weeknumber, 'String');

data = get(handles.uitable1, 'Data');
todayvalues = data;

%prediction algorithm
if str2num(currentweek) < 1
    set(handles.statustext, 'String', 'Not enough data to predict')
elseif str2num(currentweek) == 1
    set(handles.statustext, 'String', 'Using 1 week of past data')
    
    futuretemp = zeros(4,1);
    
    %do one ingredient at a time
    for row = 1:4
        dayspassed = 0;
        %iterate into the future until stock falls too low
        while todayvalues{row,2} > thresholds(row)
            dayspassed = dayspassed + 1;
            %for first week, use only one week's data
            %copies of this code below use more weeks of data in this line
            futuretemp(row) = round((tmpdays(row,1) / sum(tmpdays(row,:))) * previousweeks(row,4));
            tmpdays(row,1) = tmpdays(row, 2);
            tmpdays(row,2) = tmpdays(row, 3);
            tmpdays(row,3) = tmpdays(row, 4);
            tmpdays(row,4) = tmpdays(row, 5);
            tmpdays(row,5) = tmpdays(row, 6);
            tmpdays(row,6) = tmpdays(row, 7);
            tmpdays(row,7) = futuretemp(row);
            
            todayvalues{row,2} = todayvalues{row,2} + futuretemp(row);
        end
        
        %predict restock date and update table
        newdata = get(handles.uitable1, 'Data');
        newdata{row,3} = str2num(get(handles.daynumber, 'String')) + dayspassed;
        set(handles.uitable1, 'Data', newdata)
    end
elseif str2num(currentweek) == 2
    set(handles.statustext, 'String', 'Using 2 weeks of past data')
    
    futuretemp = zeros(4,1);
    
    for row = 1:4
        dayspassed = 0;
        while todayvalues{row,2} > thresholds(row)
            dayspassed = dayspassed + 1;
            futuretemp(row) = round((tmpdays(row,1) / sum(tmpdays(row,:))) * ((previousweeks(row,4) + previousweeks(row,3)) / 2));
            tmpdays(row,1) = tmpdays(row, 2);
            tmpdays(row,2) = tmpdays(row, 3);
            tmpdays(row,3) = tmpdays(row, 4);
            tmpdays(row,4) = tmpdays(row, 5);
            tmpdays(row,5) = tmpdays(row, 6);
            tmpdays(row,6) = tmpdays(row, 7);
            tmpdays(row,7) = futuretemp(row);
            
            todayvalues{row,2} = todayvalues{row,2} + futuretemp(row);
        end
        newdata = get(handles.uitable1, 'Data');
        newdata{row,3} = str2num(get(handles.daynumber, 'String')) + dayspassed;
        set(handles.uitable1, 'Data', newdata)
    end
elseif str2num(currentweek) == 3
    set(handles.statustext, 'String', 'Using 3 weeks of past data')
    
    futuretemp = zeros(4,1);
    
    for row = 1:4
        dayspassed = 0;
        while todayvalues{row,2} > thresholds(row)
            dayspassed = dayspassed + 1;
            futuretemp(row) = round((tmpdays(row,1) / sum(tmpdays(row,:))) * ((previousweeks(row,4) + previousweeks(row,3) + previousweeks(row,2)) / 3));
            tmpdays(row,1) = tmpdays(row, 2);
            tmpdays(row,2) = tmpdays(row, 3);
            tmpdays(row,3) = tmpdays(row, 4);
            tmpdays(row,4) = tmpdays(row, 5);
            tmpdays(row,5) = tmpdays(row, 6);
            tmpdays(row,6) = tmpdays(row, 7);
            tmpdays(row,7) = futuretemp(row);
            
            todayvalues{row,2} = todayvalues{row,2} + futuretemp(row);
        end
        newdata = get(handles.uitable1, 'Data');
        newdata{row,3} = str2num(get(handles.daynumber, 'String')) + dayspassed;
        set(handles.uitable1, 'Data', newdata)
    end
else
    set(handles.statustext, 'String', 'OK')
    
    futuretemp = zeros(4,1);
    
    for row = 1:4
        dayspassed = 0;
        while todayvalues{row,2} > thresholds(row)
            dayspassed = dayspassed + 1;
            futuretemp(row) = round((tmpdays(row,1) / sum(tmpdays(row,:))) * ((previousweeks(row,4) + previousweeks(row,3) + previousweeks(row,2) + previousweeks(row,1)) / 4));
            tmpdays(row,1) = tmpdays(row, 2);
            tmpdays(row,2) = tmpdays(row, 3);
            tmpdays(row,3) = tmpdays(row, 4);
            tmpdays(row,4) = tmpdays(row, 5);
            tmpdays(row,5) = tmpdays(row, 6);
            tmpdays(row,6) = tmpdays(row, 7);
            tmpdays(row,7) = futuretemp(row);
            
            todayvalues{row,2} = todayvalues{row,2} + futuretemp(row);
        end
        newdata = get(handles.uitable1, 'Data');
        newdata{row,3} = str2num(get(handles.daynumber, 'String')) + dayspassed;
        set(handles.uitable1, 'Data', newdata)
    end
end


% --- Executes on button press in nextweek.
function nextweek_Callback(hObject, eventdata, handles)
% hObject    handle to nextweek (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%simulate pressing a week's worth of buttons
for day = 1:7
    switch day
        case 1
            for it = 1:2
            addrandom_Callback(hObject, eventdata, handles)
            end
            nextday_Callback(hObject, eventdata, handles)
        case 2
            for it = 1:1
            addrandom_Callback(hObject, eventdata, handles)
            end
            nextday_Callback(hObject, eventdata, handles)
        case 3
            for it = 1:2
            addrandom_Callback(hObject, eventdata, handles)
            end
            nextday_Callback(hObject, eventdata, handles)
        case 4
            for it = 1:2
            addrandom_Callback(hObject, eventdata, handles)
            end
            nextday_Callback(hObject, eventdata, handles)
        case 5
            for it = 1:4
            addrandom_Callback(hObject, eventdata, handles)
            end
            nextday_Callback(hObject, eventdata, handles)
        case 6
            for it = 1:5
            addrandom_Callback(hObject, eventdata, handles)
            end
            nextday_Callback(hObject, eventdata, handles)
        case 7
            for it = 1:3
            addrandom_Callback(hObject, eventdata, handles)
            end
            nextday_Callback(hObject, eventdata, handles)
        otherwise
    end
    %updatepredictions_Callback(hObject, eventdata, handles)
end
