

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.Iterator;

// TODO: Auto-generated Javadoc
/**
 * The Class ChefProcessor.
 */
public class ChefProcessor implements Runnable {


	/** The Constant waiterIP. */
	public static final String waiterIP = "localhost";
	
	/** The Constant waiterPort. */
	public static final int waiterPort = 5000;

	/** The client socket. */
	Socket clientSocket;
	
	/** The socket input stream. */
	InputStream socketInputStream;
	
	/** The socket output stream. */
	OutputStream socketOutputStream;
	
	/** The object output stream. */
	ObjectOutputStream objectOutputStream;
	
	/** The object input stream. */
	ObjectInputStream objectInputStream;
	
	/** The gui. */
	ChefGUI GUI;


	/**
	 * Instantiates a new chef processor.
	 *
	 * @param clientSocket the client socket
	 * @param GUI the gui
	 */
	public ChefProcessor(Socket clientSocket,ChefGUI GUI) {
		this.clientSocket = clientSocket;
		this.GUI = GUI;
		
	}



	/**
	 * Parses the message processes the request to do the appropriate response.
	 */
	public void run() {

		try {
			socketInputStream = clientSocket.getInputStream();
			socketOutputStream = clientSocket.getOutputStream();
			objectOutputStream = new ObjectOutputStream(
					new BufferedOutputStream(socketOutputStream));
			objectOutputStream.flush();
			this.objectInputStream = new ObjectInputStream(
					new BufferedInputStream(socketInputStream));

			Object o = objectInputStream.readObject();


			if ( o instanceof Message.DATA_TableOrder ) {
				
				Message.DATA_TableOrder order = (Message.DATA_TableOrder) o;
				Iterator<Message.DATA_MenuItem> it=  order.menuItemList.iterator();
				while(it.hasNext())
				{
					GUI.addMenuItem(it.next());
				}
				GUI.initOrderQueue();
				
			}
			else {
				System.out.println("Recieved Unknown message!");
			}

		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}

	}
	


}
