import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JTable;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;

import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;

// TODO: Auto-generated Javadoc
/**
 * The Class ManagerUI.
 */
public class ManagerUI {

	/** The Constant controllerIP. */
	public static final String controllerIP = "localhost";

	/** The Constant controllerPORT. */
	public static final int controllerPORT = 14000;

	/** The frame. */
	private JFrame frame;

	/** The inv table. */
	private JTable invTable;

	/** The new item name. */
	private JTextField newItemName;

	/** The new menu name. */
	private JTextField newMenuName;

	/** The new item stock. */
	private JTextField newItemStock;

	/** The new menu price. */
	private JTextField newMenuPrice;

	/** The new menu ingred list. */
	private JTextField newMenuIngredList;

	/** The new menu cook time. */
	private JTextField newMenuCookTime;

	/** The new menu freshness. */
	private JTextField newMenuFreshness;

	/** The menu table. */
	private JTable menuTable;

	/** The temp menu. */
	Message.DATA_Menu tempMenu;

	/** The temp inventory. */
	Message.DATA_Inventory tempInventory;

	/**
	 * Launch the application.
	 *
	 * @param args the arguments
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					ManagerUI window = new ManagerUI();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public ManagerUI() {
		tempMenu = new Message.DATA_Menu();
		tempMenu.menuItems = new ArrayList<Message.DATA_MenuItem>();
		tempInventory = new Message.DATA_Inventory();
		tempInventory.inventoryIngredientList = new ArrayList<Message.DATA_Ingredient>();
		initialize();
	}

	/**
	 * Update display menu.
	 *
	 * @param o the o
	 */
	public void updateDisplayMenu(Message.DATA_Menu o) {
		int row = 0;
		for (Message.DATA_MenuItem item : o.menuItems) {
			menuTable.setValueAt(item.name, row, 0);
			menuTable.setValueAt(item.price, row, 1);
			row++;
		}
	}

	/**
	 * Update display inventory.
	 *
	 * @param o the o
	 */
	public void updateDisplayInventory(Message.DATA_Inventory o) {
		int row = 0;
		for (Message.DATA_Ingredient item : o.inventoryIngredientList) {
			invTable.setValueAt(item.name, row, 0);
			invTable.setValueAt(item.amount, row, 1);
			row++;
		}
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frame = new JFrame();
		frame.setBounds(100, 100, 976, 400);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(null);

		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(32, 52, 244, 281);
		frame.getContentPane().add(scrollPane);

		invTable = new JTable();
		scrollPane.setViewportView(invTable);
		invTable.setModel(new DefaultTableModel(new Object[][] {
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, }, new String[] {
				"Ingredient Name", "Quantity" }));

		JLabel lblInventory = new JLabel("Inventory Items");
		lblInventory.setBounds(32, 24, 193, 29);
		frame.getContentPane().add(lblInventory);

		JLabel lblMenu = new JLabel("Menu Items");
		lblMenu.setBounds(300, 24, 193, 29);
		frame.getContentPane().add(lblMenu);

		JLabel lblAddToInventory = new JLabel("Add to Inventory");
		lblAddToInventory.setBounds(554, 24, 193, 29);
		frame.getContentPane().add(lblAddToInventory);

		JLabel lblAddToMenu = new JLabel("Add to Menu");
		lblAddToMenu.setBounds(757, 24, 193, 29);
		frame.getContentPane().add(lblAddToMenu);

		newItemName = new JTextField();
		newItemName.setBounds(564, 88, 160, 20);
		frame.getContentPane().add(newItemName);
		newItemName.setColumns(10);

		JLabel lblName = new JLabel("Name");
		lblName.setBounds(564, 70, 46, 14);
		frame.getContentPane().add(lblName);

		newMenuName = new JTextField();
		newMenuName.setColumns(10);
		newMenuName.setBounds(767, 88, 160, 20);
		frame.getContentPane().add(newMenuName);

		JLabel label = new JLabel("Name");
		label.setBounds(767, 70, 160, 14);
		frame.getContentPane().add(label);

		JLabel InitialStock = new JLabel("Initial Stock");
		InitialStock.setBounds(564, 115, 160, 14);
		frame.getContentPane().add(InitialStock);

		newItemStock = new JTextField();
		newItemStock.setColumns(10);
		newItemStock.setBounds(564, 133, 160, 20);
		frame.getContentPane().add(newItemStock);

		JLabel lblPrice = new JLabel("Price");
		lblPrice.setBounds(767, 115, 160, 14);
		frame.getContentPane().add(lblPrice);

		newMenuPrice = new JTextField();
		newMenuPrice.setColumns(10);
		newMenuPrice.setBounds(767, 133, 160, 20);
		frame.getContentPane().add(newMenuPrice);

		JLabel lblIngredientscommaSeparated = new JLabel(
				"Ingredients (comma separated)");
		lblIngredientscommaSeparated.setBounds(767, 164, 160, 14);
		frame.getContentPane().add(lblIngredientscommaSeparated);

		newMenuIngredList = new JTextField();
		newMenuIngredList.setColumns(10);
		newMenuIngredList.setBounds(767, 182, 160, 20);
		frame.getContentPane().add(newMenuIngredList);

		JLabel lblFreshnessTime = new JLabel("Cooking Time");
		lblFreshnessTime.setBounds(767, 213, 160, 14);
		frame.getContentPane().add(lblFreshnessTime);

		newMenuCookTime = new JTextField();
		newMenuCookTime.setColumns(10);
		newMenuCookTime.setBounds(767, 231, 160, 20);
		frame.getContentPane().add(newMenuCookTime);

		JLabel lblFreshnessTime_1 = new JLabel("Freshness Time");
		lblFreshnessTime_1.setBounds(767, 262, 160, 14);
		frame.getContentPane().add(lblFreshnessTime_1);

		newMenuFreshness = new JTextField();
		newMenuFreshness.setColumns(10);
		newMenuFreshness.setBounds(767, 280, 160, 20);
		frame.getContentPane().add(newMenuFreshness);

		JButton addToInventory = new JButton("Add New Ingredient");
		addToInventory.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				// ** LOOK AT THIS **
				Message.DATA_Ingredient newIngredient = new Message.DATA_Ingredient(
						newItemName.getText(), Integer.parseInt(newItemStock
								.getText()));
				Message.Request_AddIngredient req = new Message.Request_AddIngredient();
				req.ingredient = newIngredient;
				// send new ingredient to controller
				// tempInventory.inventoryIngredientList.add(newIngredient);

				new Communicator();
				Message.DATA_Inventory inventory = (Message.DATA_Inventory) Communicator
						.sendAndRecieve(req, controllerIP, controllerPORT);
				updateDisplayInventory(inventory);

				newItemName.setText("");
				newItemStock.setText("");
			}
		});
		addToInventory.setBounds(564, 181, 160, 23);
		frame.getContentPane().add(addToInventory);

		JButton addToMenu = new JButton("Add New Menu Item");
		addToMenu.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				Message.DATA_MenuItem newMenuItem = new Message.DATA_MenuItem(
						newMenuName.getText(), Double.parseDouble(newMenuPrice
								.getText()), Integer.parseInt(newMenuCookTime
								.getText()), Integer.parseInt(newMenuFreshness
								.getText()), 0);
				// send new menuitem to controller

				Message.DATA_Ingredient bowtiepasta1 = new Message.DATA_Ingredient(
						"WheatBowTiePasta", 3);
				Message.DATA_Ingredient bowtiepasta2 = new Message.DATA_Ingredient(
						"CheeseSlice", 1);
				Message.DATA_Ingredient bowtiepasta3 = new Message.DATA_Ingredient(
						"Spice", 1);
				// Message.DATA_Ingredient bowtiepasta4 = new
				// Message.DATA_Ingredient("Tomatoes", 2);

				ArrayList<Message.DATA_Ingredient> Bow_Tie_Pasta = new ArrayList<Message.DATA_Ingredient>();
				Bow_Tie_Pasta.add(bowtiepasta1);
				Bow_Tie_Pasta.add(bowtiepasta2);
				Bow_Tie_Pasta.add(bowtiepasta3);
				// Bow_Tie_Pasta.add(bowtiepasta4);

				Message.Request_AddMenuItem req = new Message.Request_AddMenuItem();
				req.item = newMenuItem;
				req.item.menuIngredientList = Bow_Tie_Pasta;

				new Communicator();
				Message.DATA_Menu menu = (Message.DATA_Menu) Communicator
						.sendAndRecieve(req, controllerIP, controllerPORT);
				updateDisplayMenu(menu);

				newMenuName.setText("");
				newMenuPrice.setText("");
				newMenuCookTime.setText("");
				newMenuFreshness.setText("");
				newMenuIngredList.setText("");

			}
		});
		addToMenu.setBounds(766, 310, 161, 23);
		frame.getContentPane().add(addToMenu);

		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(300, 52, 244, 281);
		frame.getContentPane().add(scrollPane_1);

		menuTable = new JTable();
		scrollPane_1.setViewportView(menuTable);
		menuTable.setModel(new DefaultTableModel(new Object[][] {
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, { null, null }, { null, null },
				{ null, null }, { null, null }, }, new String[] { "Item Name",
				"Price" }));

		JButton btnNewButton = new JButton(
				"<html> Get Inventory <p> and Menu items </html>");
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Message.Request_Menu reqM = new Message.Request_Menu();
				Message.Request_Inventory reqI = new Message.Request_Inventory();

				Message.DATA_Menu menu = (Message.DATA_Menu) Communicator
						.sendAndRecieve(reqM, controllerIP, controllerPORT);
				Message.DATA_Inventory inventory = (Message.DATA_Inventory) Communicator
						.sendAndRecieve(reqI, controllerIP, controllerPORT);

				updateDisplayInventory(inventory);
				updateDisplayMenu(menu);
			}
		});
		btnNewButton.setBounds(554, 246, 183, 46);
		frame.getContentPane().add(btnNewButton);
	}
}
