import java.io.Serializable;
import java.util.ArrayList;

// TODO: Auto-generated Javadoc
/**
 * The Class Message.
 */
public class Message {

	/**
	 * The Class DATA_MenuItem.
	 */
	public static class DATA_MenuItem implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = -6614039107891427333L;

		/**
		 * Instantiates a new dAT a_ menu item.
		 *
		 * @param name the name
		 * @param price the price
		 * @param averageCookTime the average cook time
		 * @param freshnessTime the freshness time
		 * @param tableID the table id
		 */
		public DATA_MenuItem(String name, double price, int averageCookTime, int freshnessTime, int tableID) {
			this.name = name;
			this.price = price;
			this.averageCookTime = averageCookTime;
			this.freshnessTime = freshnessTime;
			this.tableID = tableID;
		}

		/** The name. */
		public String name;
		
		/** The price. */
		double price;
		
		/** The table id. */
		public int averageCookTime, freshnessTime, tableID;
		
		/** The menu ingredient list. */
		ArrayList<Message.DATA_Ingredient> menuIngredientList;
	}

	/**
	 * The Class DATA_Ingredient.
	 */
	public static class DATA_Ingredient implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = -8464549441825417157L;

		/**
		 * Instantiates a new dAT a_ ingredient.
		 *
		 * @param name the name
		 * @param amount the amount
		 */
		public DATA_Ingredient(String name, int amount) {
			this.name = name;
			this.amount = amount;
		}

		/** The type. */
		public String name, type;
		
		/** The amount. */
		public int amount;
	}

	/**
	 * The Class DATA_TableOrder.
	 */
	public static class DATA_TableOrder implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = 9044809252294526325L;

		/** The hold for table. */
		public boolean holdForTable;
		
		/** The menu item list. */
		public ArrayList<DATA_MenuItem> menuItemList;
		
		/** The table id. */
		public int currentReadyItems, totalNumItems, tableID;
	}

	/**
	 * The Class DATA_Menu.
	 */
	public static class DATA_Menu implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = -5623328477095881871L;
		
		/** The menu items. */
		ArrayList<Message.DATA_MenuItem> menuItems;
		
		/** The total. */
		int total;
	}

	/**
	 * The Class DATA_Inventory.
	 */
	public static class DATA_Inventory implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = 2811560131906454197L;
		
		/** The inventory ingredient list. */
		ArrayList<Message.DATA_Ingredient> inventoryIngredientList;
	}

	/**
	 * The Class Request_Waiter.
	 */
	public static class Request_Waiter implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = 3363303798306827190L;
		
		/** The table id. */
		int tableID;
	}

	/**
	 * The Class Request_CancelOrder.
	 */
	public static class Request_CancelOrder implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = -5126446126951813908L;
		
		/** The order id. */
		public int orderID;
	}

	/**
	 * The Class Request_Menu.
	 */
	public static class Request_Menu implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = 6543680152194431845L;
	}

	/**
	 * The Class MENU_GET_ERROR.
	 */
	public static class MENU_GET_ERROR implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = -1906233865863491984L;

	}

	/**
	 * The Class INVENTORY_GET_ERROR.
	 */
	public static class INVENTORY_GET_ERROR implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = -1059020564165465085L;
	}

	/**
	 * The Class Request_Inventory.
	 */
	public static class Request_Inventory implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = 1028464093327425264L;
	}

	/**
	 * The Class CONFIRM_PLACE_ORDER.
	 */
	public static class CONFIRM_PLACE_ORDER implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = -8437729840453697155L;
	}

	/**
	 * The Class CONFIRM_WAITER_RECEIVED_ORDER.
	 */
	public static class CONFIRM_WAITER_RECEIVED_ORDER implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = -6482605627933460812L;
	}

	/**
	 * The Class CONFIRM_WAITER_CONTACTED.
	 */
	public static class CONFIRM_WAITER_CONTACTED implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = 8794411914309448667L;
	}

	/**
	 * The Class CONFIRM_CANCEL_ORDER.
	 */
	public static class CONFIRM_CANCEL_ORDER implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = -2771233561197432175L;
	}

	/**
	 * The Class ERROR_CANNOT_COOK_ORDER.
	 */
	public static class ERROR_CANNOT_COOK_ORDER implements Serializable {
		
		/** The Constant serialVersionUID. */
		private static final long serialVersionUID = -6576535505339690271L;
	}

}
