
import javax.swing.JFrame;


import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;





// TODO: Auto-generated Javadoc
/**
 * The Class WaiterGUI.
 */
public class WaiterGUI {
	

	/** The frame that holds all the information to display. */
	public JFrame frame;
	
	/** The delivery. */
	private final LinkedList<Message.DATA_TableOrder> delivery = new LinkedList<Message.DATA_TableOrder>();//linkedList to hold the menuItems to deliver
	
	/** The wait. */
	private final LinkedList<Message.DATA_TableOrder> wait = new LinkedList<Message.DATA_TableOrder>();//linkedList to hold the menuItems to expect

	 
 	/** The order tab. */
 	private final JPanel DeliveryTab = new JPanel();//Tab that has information on the DeliveryQueue
	 //Panel that holds the buttons itself
	 /** The Order buttons. */
 	private final JPanel DeliveryButtons = new JPanel();
	 
 	/**
 	 * Launch the application.
 	 *
 	 * @param args the arguments
 	 */
	public static void main(String[] args) {

		int Port = 16000;
		/*
		 * Network variables.
		 */

				WaiterGUI GUI;
				try {

					GUI = new WaiterGUI(); // Create a new GUI window
					GUI.frame.setVisible(true);// make it visible to user
					
					// Listen for connections over the socket


					
				}
				catch (Exception e) {
					//If unable to create gui window throw error
					e.printStackTrace();
					return;
				}
				
				/*
				 * Network variables.
				 */
				Socket clientSocket;
				ServerSocket serverSocket;

				try {
					serverSocket = new ServerSocket(Port);
					

					while (true) {
						clientSocket = serverSocket.accept();
						new Thread(new WaiterProcessor(clientSocket,GUI))
								.start();
					}

				} catch (IOException e) {

					e.printStackTrace();
				}
		
		
	}

	/**
	 * Create the application.
	 */
	public WaiterGUI() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {

		//intialize frame and make it an aplication that exits when the close button has been predded
		frame = new JFrame();
		frame.setBounds(100, 100, 699, 460);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(null);
		
		//Add a tabbed frame to hold tabs
		JTabbedPane tabbedPane = new JTabbedPane(JTabbedPane.TOP);
		tabbedPane.setBounds(0, 0, 687, 421);// set the bounds
		frame.getContentPane().add(tabbedPane);//Add it to the frame for display
		
		
		//Add DeliveryQueue Tab
		tabbedPane.addTab("Delivery Queue", null, DeliveryTab, null);
		DeliveryTab.setLayout(null);
		DeliveryButtons.setBounds(0, 0, 719, 415);
		DeliveryTab.add(DeliveryButtons);
		DeliveryButtons.setLayout(null);
		

		//initialize all the tabs
		this.initDeliveryQueue();

		
		}
	//Dynamivally create buttons for the DeliveryQueueTab
	/**
	 * Inits the order queue.
	 * 
	 * Intializes the order tab with the button for each order and makes them action so that when they are clicked they are removed from the DeliveryQueue
	 */

	public void initDeliveryQueue()
	{
		DeliveryButtons.removeAll(); //Remove all the current buttons
		DeliveryButtons.updateUI(); // Update the UI window to remove all the deleted buttons
		Iterator<Message.DATA_TableOrder> it=delivery.iterator();// To iterate through all the Orders placed on the DeliveryQueue
		int bCount = 0;//Count the number of buttons made
		Message.DATA_TableOrder temp;
		while( it.hasNext() )
		{
			temp = it.next();
			//intialize the button to be displayed and give it the name of "order (ordernumber)"
			Iterator<Message.DATA_MenuItem> it2=temp.menuItemList.iterator();// To iterate through all the Orders placed on the DeliveryQueue
			String items ="";
			while( it2.hasNext() )
			{
				items+=" <p>" +it2.next().name;
			}
			JButton Item = new JButton("<html>table# "  + temp.tableID +    items  + "<html>");//ordernumber = bCount+1(makes it order 1 if bCount ==0)
			//create action when button is clicked
			Item.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					removeOrder(e.getActionCommand(), delivery ); // Remove the selected item from the oderQueue and place it on the wait queue
					initDeliveryQueue();//Reinitialize the Order Queue buttons

				}
			});
			//dynamically determine where to place the button where the bCOunt determines the grid shift on the screen
			Item.setBounds(18 + bCount*130, 11, 120, 350);
			//add button to the window
			DeliveryButtons.add(Item);
			//increment the buttonCount when it is added
			bCount++;
			DeliveryButtons.updateUI();
		}
	}
	
	/**
	 * Removes the order from the give List.
	 *
	 * @param string the string
	 * @param list the list
	 * @return the message. dat a_ table order
	 */
	private Message.DATA_TableOrder removeOrder(String string, LinkedList<Message.DATA_TableOrder> list)
	{
		String[] info= string.split(" ");
		Iterator<Message.DATA_TableOrder> it = list.iterator();
		Message.DATA_TableOrder temp;
		int ID=Integer.parseInt(info[1]);
		while( it.hasNext())
		{
			temp = it.next();
			if (temp.tableID == ID)
				return list.remove(list.indexOf(temp));
		}
		
		return null;
		
	}
	
	/**
	 * Adds the order.
	 *
	 * @param order the order
	 */
	public void addOrder(Message.DATA_TableOrder order)
	{
		System.out.println(order.tableID + " items: "+ order.totalNumItems);
		order.currentReadyItems=0;
		wait.add(order);
		
	}
	
	/**
	 * Adds the menu item.
	 *
	 * @param item the item
	 */
	public void addMenuItem(Message.DATA_MenuItem item)
	{
		System.out.println(item.name + " " +item.tableID);
		Iterator<Message.DATA_TableOrder> it = wait.iterator();
		Message.DATA_TableOrder temp;
		while( it.hasNext())
		{
			temp = it.next();
			if (temp.tableID == item.tableID)
			{
				
				if(temp.holdForTable==false)
				{
					System.out.println("here");
					Message.DATA_TableOrder order = new Message.DATA_TableOrder();
					order.tableID= item.tableID;
					order.menuItemList = new ArrayList<Message.DATA_MenuItem>();
					order.menuItemList.add(item);
					delivery.add(order);
					this.initDeliveryQueue();
					System.out.println("here");
				}
				temp.currentReadyItems++;
				System.out.println(temp.currentReadyItems);
				if(temp.currentReadyItems == temp.totalNumItems )
					if(temp.holdForTable == true)
					{
						System.out.println("here");
						delivery.add(removeOrder("order "+ temp.tableID, wait));
						this.initDeliveryQueue();
					}
					else
						removeOrder("order "+ temp.tableID, wait);
				break;
			}
		}
	}
}
