// Written By: Sai Kotikalapudi 
// Debugged By: Sai Kotikalapudi
// Tested By: Sai Kotikalapudi

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.net.UnknownHostException;

// TODO: Auto-generated Javadoc
/**
 * The Class ChefCommunicator.
 */
public class ChefCommunicator {

		

	  /**
	 * Send and recieve an object on a specified port and host.
	 *
	 * @param o the o
	 * @param host the host
	 * @param port the port
	 * @return the object
	 */
	public static Object sendAndRecieve(Object o, String host, int port) {
		try {
			Socket clientSocket = new Socket(host, port);

			InputStream socketInputStream = clientSocket.getInputStream();
			OutputStream socketOutputStream = clientSocket.getOutputStream();
			ObjectOutputStream objectOutputStream = new ObjectOutputStream(
					new BufferedOutputStream(socketOutputStream));
			objectOutputStream.flush();
			ObjectInputStream objectInputStream = new ObjectInputStream(new BufferedInputStream(
					socketInputStream));

			objectOutputStream.writeObject(o);
			objectOutputStream.flush();

			Object ret = objectInputStream.readObject();

			objectOutputStream.close();
			objectInputStream.close();

			return ret;

		} catch (UnknownHostException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		return null;
	 }

	  /**
	 * Send the object to a specified port and host.
	 *
	 * @param o the object to send
	 * @param host the host
	 * @param port the port
	 */
	public static void send(Object o, String host, int port) {
		try {
			Socket clientSocket = new Socket(host, port);

			OutputStream socketOutputStream = clientSocket.getOutputStream();
			ObjectOutputStream objectOutputStream = new ObjectOutputStream(
					new BufferedOutputStream(socketOutputStream));
			objectOutputStream.flush();
			objectOutputStream.writeObject(o);
			objectOutputStream.flush();

			objectOutputStream.close();

		} catch (UnknownHostException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}


}
