/**
 * The Class TableOrder is a container for a table order.
 * It does not contain all the items related to an actual
 * table order but rather just the items that make the
 * Waiter GUI functional.
 */
public class TableOrder {

	/** The id of the table order. */
	int id;

	/** The current number of menu items
	 * that are ready for this table order. */
	int currentNumMenuItems;

	/** The total number of menu items that are
	 * in this table order. */
	int totalNumMenuItems;

	/** The table number associated with this table order. */
	int tableNum;

	/** The menu item IDs associated with this table order
	 * placed inside a string a delimited with commas. */
	String menuItemIDs;


	/**
	 * Instantiates a new table order.
	 *
	 * @param id the id of the table order.
	 * @param totalNumMenuItems the total number of menu items
	 * @param tableNum the table number
	 * @param menuItemIDs the menu item IDs. comma delimited
	 */
	public TableOrder(int id, int totalNumMenuItems, int tableNum, String menuItemIDs) {
		this.id = id;
		this.currentNumMenuItems = 0;
		this.totalNumMenuItems = totalNumMenuItems;
		this.tableNum = tableNum;
		this.menuItemIDs = menuItemIDs;
	}


	/**
	 * toString method for the table order.
	 */
	public String toString() {
		return "Table Order " + id + ", current: " + currentNumMenuItems + " total: " + totalNumMenuItems;
	}

}
